-- door state machine

beginStateMachine()

	onEnter(function(msg)
		setState("closed")
	end )

	state("closed")
		onEnter(function(msg)
			setWalkability(0);
		end )
		
		onMsg("openDoorLeft", function(msg)
			setState("openLeft");
		end )
		
		onMsg("openDoorRight", function(msg)
			setState("openRight");
		end )
		
		onMsg("buildMenu", function(msg)
			-- build the pie menu
			clearPieMenu();
			local button ;
			button = addPieMenuButton("pm_open", "openDoorLeft");
			button.addDescription(USERACTION, "true");
		end )
	
	state("openLeft")
		
		onEnter(function(msg)
			startAnimation("doorOpenLeft");
			setWalkability(1)
			playSound("doorOpenClose");
		end )
		
		onExit(function(msg)
			startAnimation("doorCloseLeft");
		end )
		
		onMsg("closeDoorLeft", function(msg)
			setState("closed");
		end )
		
		onMsg("closeDoorRight", function(msg)
			setState("closed");
		end )
		
		onMsg("buildMenu", function(msg)
			-- build the pie menu
			clearPieMenu();
			local button ;
			button = addPieMenuButton("pm_close", "closeDoorLeft");
			button.addDescription(USERACTION, "true");
		end )
		
	state("openRight")
	
		onEnter(function(msg)
			startAnimation("doorOpenRight");
			setWalkability(2)
			playSound("doorOpenClose");
		end )
		
		onExit(function(msg)
			startAnimation("doorCloseRight");
		end )
		
		onMsg("closeDoorLeft", function(msg)
			setState("closed");
		end )
		
		onMsg("closeDoorRight", function(msg)
			setState("closed");
		end )
		
		onMsg("buildMenu", function(msg)
			-- build the pie menu
			clearPieMenu();
			local button ;
			button = addPieMenuButton("pm_close", "closeDoorRight");
			button.addDescription(USERACTION, "true");
		end )
	
endStateMachine()
